Bug 428920 - user data corruption on misaligned access with certain FP instructions
user data corruption on misaligned access with certain FP instructions
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.0
ia64 Linux
high Severity high
: rc
: ---
Assigned To: Luming Yu
Martin Jenner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-15 20:08 EST by Tony Luck
Modified: 2013-08-05 21:43 EDT (History)
10 users (show)

See Also:
Fixed In Version: RHBA-2008-0314
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-05-21 11:06:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
git commit - has description & patch (1.96 KB, patch)
2008-01-15 20:08 EST, Tony Luck
no flags Details | Diff
testcase (626 bytes, application/x-gzip-compressed)
2008-01-24 16:43 EST, Tony Luck
no flags Details

  None (edit)
Description Tony Luck 2008-01-15 20:08:37 EST
Description of problem:
Kernel does not correctly handle certain floating point unaligned data traps.

Version-Release number of selected component (if applicable):
All kernel versions ever (do you need separate bugzilla for RHEL4?)

How reproducible:
With the right test program and test data - every time

Steps to Reproduce:
1. Run a program that uses "ldf" instruction from an unaligned address, using
update register addressing.
2. Observe register is not adjusted correctly (will always increment by 0x10)
  
Actual results:
Wrong updated register

Expected results:


Additional info:
Sent patch to Linus ... should be in hi git tree with commit id
1a499150e4ec1299232e24389f648d059ce5617a as soon as he pulls from my tree.
Comment 1 Tony Luck 2008-01-15 20:08:37 EST
Created attachment 291782 [details]
git commit - has description & patch
Comment 3 Tony Luck 2008-01-24 16:43:15 EST
Created attachment 292864 [details]
testcase

$ tar xzf fptest.tgz
$ make
$ ./try

Two "PASS!" lines expected (and you'll get them when running a kernel with
patch applied).
Comment 4 Luming Yu 2008-01-25 22:59:43 EST
I'm going to assign the bug to me..
Comment 6 RHEL Product and Program Management 2008-01-31 11:07:28 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 8 Don Zickus 2008-02-01 16:11:00 EST
in 2.6.18-77.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 9 Tony Luck 2008-02-01 16:56:05 EST
Don.  Grabbed that 2.6.18-77.el5 rpm and installed on my hp zx2000 workstation. 
The floating point problem is fixed (my test case passes).

But some other stuff in there doesn't play well with the rest of my system as X 
refused to start.  I'm running a fairly pure RHEL5 (no updates) ... so maybe 
some bits are too old to work with the new kernel?
Comment 10 Luming Yu 2008-02-02 00:08:28 EST
X server failed to start with 2.6.18-71 on my Hitachi Coldfusion 4s4u..
After reverting patch for bug#240006, the X server works again:

linux-2.6-ia64-ioremap-allow-cacheable-mmaps-of-legacy_mem.patch:Bugzilla: 240006
linux-2.6-ia64-ioremap-avoid-unsupported-attributes.patch:Bugzilla: 240006
linux-2.6-ia64-ioremap-fail-mmaps-with-incompat-attributes.patch:Bugzilla: 240006
linux-2.6-ia64-ioremap-rename-variables-to-match-i386.patch:Bugzilla: 240006
linux-2.6-ia64-validate-and-remap-mmap-requests.patch:Bugzilla: 240006
linux-2.6-xen-ia64-make-ioremapping-work.patch:Bugzilla: 240006
Comment 11 Doug Chapman 2008-02-02 00:21:33 EST
The X server needs to be updated.  The changes Luming references in comment #10
and the X server changes were made at the same time.  I think somebody (ajax
perhaps) posted the updated X server rpms on people.redhat.com.

- Doug
Comment 12 Luming Yu 2008-02-02 02:24:17 EST
I also tried upstream 2.6.23-rc8 , get same problem on the hitachi coldfusion
4s4u. So the patch series should have been upstream for a while...

Doug, could you please point me a link to the page to test the updated X server.
the people.redhat.com/ajax doesn't work.

Comment 13 Doug Chapman 2008-02-02 04:19:49 EST
(In reply to comment #12)
> 
> Doug, could you please point me a link to the page to test the updated X server.
> the people.redhat.com/ajax doesn't work.
> 
> 

The updated X server rpm's can be found here:
http://people.redhat.com/ajackson/233981/
Comment 14 Luming Yu 2008-02-03 00:53:45 EST
installed kernel-2.6.18-77.el5,
but installing xorg-x11-server-Xorg-1.1.1-48.32.el5.ia64.rpm ends up error:
Failed dependencies:
        kernel < 2.6.18-60.el5 conflicts with xorg-x11-server-Xorg-1.1.1-48.32.e
l5.ia64

Comment 15 Suzanne Yeghiayan 2008-02-05 00:02:21 EST
Luming, we currently have xorg-x11-server-1.1.1-48.34.el5 in the xorg-x11-server
erratum at http://errata.devel.redhat.com/errata/show/6891.  Can you retest with
that package and kernel-2.6.18-77.el5 please?
Comment 16 Luming Yu 2008-02-13 01:29:03 EST
re-checked the kernel packages, found that the box has multiple kernel packages
installed, some kernel like 2.6.18-53 and 44 are older than 2.6.18-60.el5...
And the rpm installation dependency check seems to require all kernel packages
installed >=2.6.18-60.el5.

Now I have installed xorg-x11-server-Xorg-1.1.1-48.32.el5.ia64.rpm , and the X
server works with the kernel-2.6.18-77.el5
Comment 18 ryan 2008-03-13 13:26:39 EDT
hello, what's the latest update of this bug?
Comment 19 ryan 2008-03-14 05:40:23 EDT
hello, where can I get kernel-2.6.18-77.el5? thanks !

Comment 20 Ronald Pacheco 2008-03-17 16:15:44 EDT
Ryan,

Please go to the public beta in the RHN beta channel.
Comment 22 errata-xmlrpc 2008-05-21 11:06:32 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2008-0314.html

Note You need to log in before you can comment on or make changes to this bug.